/* Bit value widget -*-c++-*- */
#ifndef KCBITEDIT_H__
#define KCBITEDIT_H__

#include <qvalidator.h>

#include "kcporteditbase.h"

struct expr_code;
class KCMainWin;

class KCBitEdit: public KCPortEditBase
{ 
  Q_OBJECT
public:
  KCBitEdit (QWidget *parent = 0, const char* name = 0);
  ~KCBitEdit ();
  /** Set control to bit of expr with name */
  void setBit (const QString &name, const QString &expr, unsigned bit);
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Set KCMainWin to task to update all views to win */
  void setMainWin (KCMainWin *win);

protected slots:
  /** Try to modify the bit according to user's change */
  void editAcceptChanges ();
  /** Edit gained focus */
  void editFocusGained ();

private:
  struct expr_code *compiled;
  QString expr_;
  KCMainWin *mainWin;
  unsigned bit_;
  bool modifying;
};

#endif
