/* Breakpoint window -*-c++-*- */
#ifndef KCBREAKWIN_H__
#define KCBREAKWIN_H__

#include <kxmlguibuilder.h>
#include <kxmlguiclient.h>

#include "kclistview.h"
#include "kcwindow.h"

class KAction;
class KCMainWin;
class KXMLGUIFactory;
class QKeyEvent;

/** Breakpoint window */
class KCBreakWin: public KCListView, public KCWindow, protected KXMLGUIBuilder,
		  virtual protected KXMLGUIClient
{
  Q_OBJECT

public:
  KCBreakWin (KCMainWin *mainWin, QWidget *parent = 0, const char *name = 0);
  ~KCBreakWin ();
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Save current UI state under uiState */
  void saveState (struct _xmlNode *uiState);
  /** The same as QWidget::close, but we don't inherit QWidget */
  void cerealClose ();
  /** Load UI state from node of doc;
      returns: 0 if OK, -1 on error */
  int loadState (struct _xmlDoc *doc, struct _xmlNode *node);

public slots: /* Called from KCMainWin */
  /** Insert new breakpoint */
  void insertBreak ();
  /** Delete currently selected breakpoint */
  void deleteBreak ();
  /** Edit currently selected breakpoint */
  void editBreak ();
protected slots:
  /** Enable/disable breakpoint actions */
  void resetBreakActions ();
  /** Show context menu */
  void showContextMenu (KListView *, QListViewItem *, const QPoint &p);
  
private:
  /* For giving different watch windows different titles */
  static unsigned title_index;
  KAction *deleteAction, *propertiesAction;
  KXMLGUIFactory *factory;
};

#endif
