/* KListView with additional signals */

#include "kclistview.h"

KCListView::KCListView (QWidget *parent, const char *name)
  : KListView (parent, name)
{
}

KCListView::~KCListView ()
{
}

/** Handle Insert and Delete keys */
void
KCListView::keyPressEvent (QKeyEvent *event)
{
  if (event->key () == Qt::Key_Insert)
    {
      emit insertPressed ();
      event->accept ();
    }
  else if (event->key () == Qt::Key_Delete && selectedItem () != 0)
    {
      emit deletePressed ();
      event->accept ();
    }
  else
    KListView::keyPressEvent (event);
}

/** Emit focusGained () */
void
KCListView::focusInEvent (QFocusEvent *event)
{
  emit focusGained ();
  KListView::focusInEvent (event);
}

/** Emit focusLost () */
void
KCListView::focusOutEvent (QFocusEvent *event)
{
  emit focusLost ();
  KListView::focusOutEvent (event);
}
