/* KListView with additional signals -*-c++-*- */
#ifndef KCLISTVIEW_H__
#define KCLISTVIEW_H__

#include <klistview.h>

class KCListView: public KListView
{
  Q_OBJECT

public:
  KCListView (QWidget *parent = 0, const char *name = 0);
  ~KCListView ();

signals:
  /** Delete key was pressed */
  void deletePressed ();
  /** Insert key was pressed */
  void insertPressed ();
  /** This window has lost focus */
  void focusLost ();
  /** This window has gained focus */
  void focusGained ();

protected:
  /** Handle Insert and Delete keys */
  void keyPressEvent (QKeyEvent *event);
  /** Emit focusGained () */
  void focusInEvent (QFocusEvent *event);
  /** Emit focusLost () */
  void focusOutEvent (QFocusEvent *event);
};

#endif
