/* Port value widget -*-c++-*- */
#ifndef KCPORTEDIT_H__
#define KCPORTEDIT_H__

#include "kcporteditbase.h"

struct expr_code;
class KCMainWin;

class KCPortEdit: public KCPortEditBase
{ 
  Q_OBJECT
public:
  KCPortEdit (QWidget *parent = 0, const char* name = 0);
  ~KCPortEdit ();
  /** Set control to expr with name */
  void setExpression (const QString &name, const QString &expr);
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Set KCMainWin to task to update all views to win */
  void setMainWin (KCMainWin *win);
  
signals:
  /** The edit box in KCPortEdit widget has gained focus */
  void focusGained (QWidget *widget);

protected slots:
  /** Try to modify the port according to user's change */
  void editAcceptChanges ();
  /** Edit gained focus */
  void editFocusGained ();

private:
  struct expr_code *compiled;
  QString expr_;
  KCMainWin *mainWin;
  bool modifying;
};

#endif
