/* Select Module dialog -*-c++-*- */

#include <klistbox.h>
#include <kpushbutton.h>
#include <kstdguiitem.h>

#include <me.h>

#include "kcselectmoduledialog.h"

/** Create an "select module" dialog for module type */
KCSelectModuleDialog::KCSelectModuleDialog (QWidget *parent,
					    const struct cereal_module *type)
  : KCSelectModuleDialogBase (parent)
{
  cancelButton->setGuiItem (KStdGuiItem::cancel ());
  OKButton->setGuiItem (KStdGuiItem::ok ());

  for (const struct me_entry *me = me_list; me != NULL; me = me->next)
    {
      if (me->module == type)
	moduleList->insertItem (me->name);
    }
  moduleList->sort ();
  QListBoxItem *first = moduleList->firstItem ();
  if (first != 0)
    {
      moduleList->setCurrentItem (first);
      moduleList->setSelected (first, false);
    }
  
  OKButton->setEnabled (false);
}

KCSelectModuleDialog::~KCSelectModuleDialog ()
{
}

/** @returns module selected by user */
struct me_entry *
KCSelectModuleDialog::selectedModule () const
{
  if (moduleList->currentItem () == -1)
    return NULL;
  return me_find (moduleList->currentText ());
}

/** Return key was pressed */
void
KCSelectModuleDialog::returnPressed ()
{
  if (moduleList->currentItem () != -1)
    accept ();
}

/** moduleList selection has changed */
void
KCSelectModuleDialog::selectionChanged ()
{
  OKButton->setEnabled (moduleList->currentItem () != -1);
}
