/* Watch window -*-c++-*- */
#ifndef KCWATCHWIN_H__
#define KCWATCHWIN_H__

#include <kxmlguibuilder.h>
#include <kxmlguiclient.h>

#include "kclistview.h"
#include "kcwindow.h"

class KAction;
class KCMainWin;
class KXMLGUIFactory;
class QKeyEvent;

/** Watch window */
class KCWatchWin: public KCListView, public KCWindow, protected KXMLGUIBuilder,
		  virtual protected KXMLGUIClient
{
  Q_OBJECT

public:
  KCWatchWin (KCMainWin *mainWin, QWidget *parent = 0, const char *name = 0);
  ~KCWatchWin ();
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Save current UI state under uiState */
  void saveState (struct _xmlNode *uiState);
  /** The same as QWidget::close, but KCWindow doesn't inherit QWidget */
  void cerealClose ();
  /** Load UI state from node of doc;
      returns: 0 if OK, -1 on error */
  int loadState (struct _xmlDoc *doc, struct _xmlNode *node);

public slots: /* Called from KCMainWin */
  /** Insert new watch */
  void insertWatch ();
  /** Delete currently selected watch */
  void deleteWatch ();
  /** Edit currently selected watch */
  void editWatch ();
protected slots:
  /** Enable/disable watch actions */
  void resetWatchActions ();
  /** Show context menu */
  void showContextMenu (KListView *, QListViewItem *, const QPoint &p);
  
private:
  /* For giving different watch windows different titles */
  static unsigned title_index;
  KAction *deleteAction, *propertiesAction;
  KXMLGUIFactory *factory;
};

#endif
