/* Abstract base class for cereal view windows -*-c++-*- */
#ifndef KCWINDOW_H__
#define KCWINDOW_H__

struct _xmlNode;
class KCMainWin;

class KCWindow
{
public:
  /** Register itself in mainWin_ */
  KCWindow (KCMainWin *mainWin_);
  /** Unregister itself in mainWin */
  virtual ~KCWindow ();
  /** Update view because emulation state has changed */
  virtual void cerealUpdate () = 0;
  /** Save current UI state under uiState */
  virtual void saveState (struct _xmlNode *uiState) = 0;
  /** The same as QWidget::close, but KCWindow doesn't inherit QWidget */
  virtual void cerealClose () = 0;
private:
  KCMainWin *mainWin;
};

#endif

