/* 8051 plugin factory */

#include <kinstance.h>

#include "kc8051.h"
#include "kc8051factory.h"

KC8051Factory::KC8051Factory (QObject *parent, const char *name)
  : KLibFactory (parent, name)
{
  instance = new KInstance ("KC8051Factory");
}

KC8051Factory::~KC8051Factory ()
{
  delete instance;
}

QObject *
KC8051Factory::createObject (QObject *parent, const char *name, const char *,
			     const QStringList &)
{
  QObject *obj = new KC8051 (parent, name);
  emit objectCreated (obj);
  return obj;
}

KInstance *KC8051Factory::instance = 0;

extern "C" void *
init_libkc8051 ()
{
  return new KC8051Factory;
}
