/* 8051 view window -*-c++-*- */
#ifndef KC8051VIEWWIN_H__
#define KC8051VIEWWIN_H__

#include "../kde/kcwindow.h"

#include "kc8051viewwinbase.h"

struct expr_code;
struct me_entry;
class KCMainWin;

class KC8051ViewWin: public KC8051ViewWinBase, public KCWindow
{
  Q_OBJECT
public:
  KC8051ViewWin (KCMainWin *mainWin, struct me_entry *me, QWidget *parent = 0,
		 const char *name = 0);
  ~KC8051ViewWin ();
  /** Update view because emulation state has changed */
  void cerealUpdate ();
  /** Save current UI state under uiState */
  void saveState (struct _xmlNode *uiState);
  /** Load UI state from node of doc;
      returns: 0 if OK, -1 on error */
  int loadState (struct _xmlDoc *doc, struct _xmlNode *node);
  /** The same as QWidget::close, but we don't inherit QWidget */
  void cerealClose ();

protected slots:
  /** Byte edit widget was selected, use it in bits display */
  void selectByte (QWidget *widget);

private:
  struct me_entry *me_;
  /** Value of PC last time we were disassembling an instruction */
  int last_pc;
  /** Compiled expressions for @/misc16/prev_pc, @/prev_insn/[012],
      @/misc16/pc */
  struct expr_code *prev_pc, *prev_insn[3], *next_pc;
};

#endif
