/* Item/Properties dialog -*-c++-*- */
#ifndef KHWPROPERTIESDIALOG_H__
#define KHWPROPERTIESDIALOG_H__

#include <qmap.h>

#include "khwpropertiesdialogbase.h"

struct connect_entry;
struct me_entry;
class KHwConnListItem;

class KHwPropertiesDialog: public KHwPropertiesDialogBase
{
  Q_OBJECT
public:
  KHwPropertiesDialog (QWidget *parent, struct me_entry *me_);
  ~KHwPropertiesDialog ();

protected slots:
  /** connection selection has changed */
  void connectionSelectionChanged ();
  /** Delete selected connection */
  void deleteConnection ();
  /** Modify selected connection */
  void modifyConnection();
  /** Create a new connection */
  void newConnection();
  /** Option selection has changed */
  void optionSelectionChanged ();
  /** Tab was switched */
  void tabSwitched (QWidget *);
  /** Check if optionValue is OK, and accept () if so */
  void tryAccept ();

private:
  /** Set prev_option to optionValue. @returns true on success */
  bool setOption ();
  /** Find KHwConnListItem for conn */
  KHwConnListItem *findConn (const struct connect_entry *conn);
  /** Rebuild connectionList */
  void rebuildConnectionList ();
  struct me_entry *me;
  QListViewItem *prev_option;
  QMap<QString, QString> descriptions;
  bool modified;
  QString last_err_val;
  QListViewItem *last_err_option;
};

#endif
