/* get_num () */
#include <config.h>

#include <errno.h>
#include <stdlib.h>

#include <lib.h>

/* Parse a number-only argument STRING with strtoul-like BASE, store result
   to *RES;
   returns: 0 if OK, -1 on error */
int
get_num (const char *string, int base, unsigned long *res)
{
  unsigned long val;
  char *tail;

  errno = 0;
  val = strtoul (string, &tail, base);
  if (tail == string || *tail != 0 || errno != 0)
    {
      error (0, "`%s' is not a valid number", string);
      return -1;
    }
  *res = val;
  return 0;
}
