/* get_xml_enum () */

#include <string.h>
#include <libxml/tree.h>

#include <lib.h>

/* Load *VAL from xml element NODE of DOC, containing one of NUM STRINGS;
   returns: 0 if OK, -1 on error */
int
get_xml_enum (struct _xmlDoc *doc, struct _xmlNode *node,
	      const char *const *strings, size_t num, unsigned *val)
{
  xmlChar *str;
  const char *const *p;

  str = xmlNodeListGetString (doc, node->children, 1);
  if (str == NULL)
    goto err;
  for (p = strings; p < strings + num; p++)
    {
      if (strcmp (*p, str) == 0)
	{
	  *val = p - strings;
	  xmlFree (str);
	  return 0;
	}
    }
 err:
  xmlFree (str);
  error (0, "invalid enumeration value");
  return -1;
}
